import hashlib
import mmh3
from bitarray import bitarray

class BloomFilter(object):

    def __init__(self, size, hash_count):
        self.size = size
        self.hash_count = hash_count
        self.bit_array = bitarray(size)
        self.bit_array.setall(0)

    def add(self, item):
        for seed in range(self.hash_count):
            index = mmh3.hash(item, seed) % self.size
            self.bit_array[index] = 1

    def contains(self, item):
        for seed in range(self.hash_count):
            index = mmh3.hash(item, seed) % self.size
            if self.bit_array[index] == 0:
                return False
        return True

    # def __init__(self, size, number_expected_elements=100000):
    #     self.size = size
    #     self.number_expected_elements = number_expected_elements
    #
    #     self.bloom_filter = bitarray(self.size)
    #     self.bloom_filter.setall(0)
    #
    #     self.number_hash_functions = round((self.size / self.number_expected_elements) * math.log(2))
    #
    # # основная хеш-функция
    # def _hash_djb2(self, s):
    #     hash = 5381
    #     for x in s:
    #         hash = ((hash << 5) + hash) + ord(x)
    #     return hash % self.size
    #
    # # симулируем создания множества хеш-функций
    # def _hash(self, item, K):
    #     return self._hash_djb2(str(K) + item)
    #
    # # добавление нового элемента в фильтр Блума
    # def add_to_filter(self, item):
    #     for i in range(self.number_hash_functions):
    #         self.bloom_filter[self._hash(item, i)] = 1
    #
    # # проверка н наличие элемента в фильторе Блума
    # def check_is_not_in_filter(self, item):
    #     for i in range(self.number_hash_functions):
    #         if self.bloom_filter[self._hash(item, i)] == 0:
    #             return True
    #     return False